// SPDX-License-Identifier: GPL-2.0+
/*
 * Copyright (c) 2023, Qualcomm Innovation Center, Inc. All rights reserved.
 */

#ifndef _IPQ9574_H_
#define _IPQ9574_H_

#include <configs/ipq9574.h>
#include <asm/u-boot.h>

typedef enum {
	SMEM_SPINLOCK_ARRAY = 7,
	SMEM_AARM_PARTITION_TABLE = 9,
	SMEM_HW_SW_BUILD_ID = 137,
	SMEM_USABLE_RAM_PARTITION_TABLE = 402,
	SMEM_POWER_ON_STATUS_INFO = 403,
	SMEM_MACHID_INFO_LOCATION = 425,
	SMEM_IMAGE_VERSION_TABLE = 469,
	SMEM_BOOT_FLASH_TYPE = 498,
	SMEM_BOOT_FLASH_INDEX = 499,
	SMEM_BOOT_FLASH_CHIP_SELECT = 500,
	SMEM_BOOT_FLASH_BLOCK_SIZE = 501,
	SMEM_BOOT_FLASH_DENSITY = 502,
	SMEM_BOOT_DUALPARTINFO = 503,
	SMEM_PARTITION_TABLE_OFFSET = 504,
	SMEM_SPI_FLASH_ADDR_LEN = 505,
	SMEM_FIRST_VALID_TYPE = SMEM_SPINLOCK_ARRAY,
	SMEM_LAST_VALID_TYPE = SMEM_SPI_FLASH_ADDR_LEN,
	SMEM_MAX_SIZE = SMEM_SPI_FLASH_ADDR_LEN + 1,
} smem_mem_type_t;

/* MACH IDs for various RDPs */
#define MACH_TYPE_IPQ9574_RDP417		0x8050000
#define MACH_TYPE_IPQ9574_RDP418		0x8050001
#define MACH_TYPE_IPQ9574_RDP418_EMMC		0x8050101
#define MACH_TYPE_IPQ9574_RDP437		0x8050201
#define MACH_TYPE_IPQ9574_RDP433		0x8050301
#define MACH_TYPE_IPQ9574_RDP433_WNC_FREEDOM	0x8050301
#define MACH_TYPE_IPQ9574_RDP449		0x8050501
#define MACH_TYPE_IPQ9574_RDP433_MHT_PHY	0x8050601
#define MACH_TYPE_IPQ9574_RDP453		0x8050701
#define MACH_TYPE_IPQ9574_RDP454		0x8050801
#define MACH_TYPE_IPQ9574_RDP433_MHT_SWT	0x8050901
#define MACH_TYPE_IPQ9574_RDP467		0x8051301
#define MACH_TYPE_IPQ9574_RDP455_C11		0x8050A01
#define MACH_TYPE_IPQ9574_RDP455_C12		0x8050B01
#define MACH_TYPE_IPQ9574_RDP459		0x8050C01
#define MACH_TYPE_IPQ9574_RDP457		0x8050E01
#define MACH_TYPE_IPQ9574_RDP456		0x8050F01
#define MACH_TYPE_IPQ9574_RDP458		0x8050102
#define MACH_TYPE_IPQ9574_RDP469		0x8051001
#define MACH_TYPE_IPQ9574_RDP461		0x8051201
#define MACH_TYPE_IPQ9574_RDP475		0x8050003
#define MACH_TYPE_IPQ9574_RDP476		0x8050004
#define MACH_TYPE_IPQ9574_DB_AL01_C1		0x1050000
#define MACH_TYPE_IPQ9574_DB_AL01_C2		0x1050100
#define MACH_TYPE_IPQ9574_DB_AL01_C3		0x1050200
#define MACH_TYPE_IPQ9574_DB_AL02_C1		0x1050001
#define MACH_TYPE_IPQ9574_DB_AL02_C2		0x1050101
#define MACH_TYPE_IPQ9574_DB_AL02_C3		0x1050201

/* Crashdump Magic registers & values */
#define TCSR_BOOT_MISC_REG			((u32*)0x193D100)

#define DLOAD_MAGIC_COOKIE			0x10
#define DLOAD_DISABLED				0x40
#define DLOAD_ENABLE				BIT(4)
#define DLOAD_DISABLE				(~BIT(4))
#define CRASHDUMP_RESET				BIT(11)

/* DT Fixup nodes */
#define LINUX_5_4_NAND_DTS_NODE		"/soc/nand@79b0000/"
#define LINUX_5_4_MMC_DTS_NODE		"/soc/sdhci@7804000/"
#define LINUX_5_4_USB_DTS_NODE		"/soc/usb3@8A00000/dwc3@8A00000/"
#define LINUX_5_4_USB_DR_MODE_FIXUP	"/soc/usb3@8A00000/dwc3@8A00000%dr_mode%?peripheral"
#define LINUX_5_4_USB_MAX_SPEED_FIXUP	"/soc/usb3@8A00000/dwc3@8A00000%maximum-speed%?high-speed"

#define LINUX_6_x_NAND_DTS_NODE		"/soc@0/nand@79b0000/"
#define LINUX_6_x_MMC_DTS_NODE		"/soc@0/mmc@7804000/"
#define LINUX_6_x_USB_DTS_NODE		"/soc@0/usb3@8a00000/usb@8a00000/"
#define LINUX_6_x_USB_DR_MODE_FIXUP	"/soc@0/usb3@8a00000/usb@8a00000%dr_mode%?peripheral"
#define LINUX_6_x_USB_MAX_SPEED_FIXUP	"/soc@0/usb3@8a00000/usb@8a00000%maximum-speed%?high-speed"

#define LINUX_RSVD_MEM_DTS_NODE		"/reserved-memory/"
#define STATUS_OK			"status%?okay"
#define STATUS_DISABLED			"status%?disabled"

#endif /* _IPQ9574_H_ */
